//+
//+     Thanks extendedstatusbar, livehttpheaders and imagelikeopera !!!
//+
//+     This plugin monitor defined you HTTP response header of top level requesting document.
//+     Header defined in pref "extensions.headermonitor.header"
//+     (default monitoring header "Content-Encoding")
//+	Header changes come into effect after restart browser.
//+     
//+
//+

var hmFlag = false;
var hmDefStatus = "none";
var hmReqStatus = "req";
var hmCurStatus = hmDefStatus;
var hmSettingsHdr = "Content-Encoding";
var hmDefHost = "none"
var hmCurHost = hmDefHost;

const HM_PREF_SERVICE = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService);

const HM_PREF_BRANCH = HM_PREF_SERVICE.getBranch("extensions.headermonitor.");

const HM_OBSERV_SERVICE = Components.classes["@mozilla.org/observer-service;1"]
        .getService(Components.interfaces.nsIObserverService);


try { hmSettingsHdr = HM_PREF_BRANCH.getCharPref("header"); }
  catch(e) { HM_PREF_BRANCH.setCharPref("header", hmSettingsHdr);}

var hmBrowser = getBrowser();

var hmObj = {
	observe: function(hmSubject,hmTopic,hmData){
//	dump("\nHIT: "+hmFlag);
//	hmSubject.QueryInterface(Components.interfaces.nsIRequest);

	if( hmFlag ) {return true; }
//	  if ( hmSubject.loadFlags & Components.interfaces.nsIRequest.VALIDATE_NEVER ) 
//	   {	var hmTab = hmBrowser.selectedBrowser;
//		hmCurStatus = hmTab.hmTabStatus; dump("\nCache!");  
//		return true;
//	   }
		hmSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
    try
      {
		hmCurStatus = hmSubject.getResponseHeader(hmSettingsHdr);
		hmCurHost = hmSubject.getRequestHeader("Host");

      } catch(e) { }
//	dump("\nHIT host: " +hmCurHost+"\treq: "+hmCurStatus);

	if(hmCurHost != hmDefHost) { hmFlag=true; }
	  }
};

//var hmObjNav = {
//	observe: function(hmSubject,hmTopic,hmData){ 
//hmTest();
//
// }
//};

eval('gBrowser.addTab =' + hmBrowser.addTab.toString().replace(
'if (!blank) {',
'   b.hmTabStatus = hmDefStatus; \
    hmCurHost = hmDefHost; \
    hmFlag = false; \
    if (!blank) { b.hmTabStatus = hmReqStatus;')
);

hmBrowser.selectedBrowser.hmTabStatus = hmDefStatus;

function hmTabSelect()
{
    var hmTab = hmBrowser.selectedBrowser;
    var hmStatus = document.getElementById("hmStatus");
//    hmStatus.label = hmSettingsHdr + ": " + hmTab.hmTabStatus;
if(hmTab.hmTabStatus == hmReqStatus) 
	{ hmStatus.label = hmSettingsHdr + ": " + hmCurStatus; }
   else { hmStatus.label = hmSettingsHdr + ": " + hmTab.hmTabStatus; }
    hmStatus.collapsed = false;
//    dump("\n Select Tab!");

}

//function hmTest()
//{
//    dump("\n New Tab!");
//}
	
const STATE_START =
  Components.interfaces.nsIWebProgressListener.STATE_START;

const STATE_STOP =
  Components.interfaces.nsIWebProgressListener.STATE_STOP;

function registerAdvStatusListener()
{
  advStatusListener.init();
  window.getBrowser().addProgressListener(advStatusListener , STATE_START);
}

function unregisterAdvStatusListener()
{
  advStatusListener.destroy();
  window.getBrowser().removeProgressListener(advStatusListener , STATE_STOP);
}


window.addEventListener("load",registerAdvStatusListener,false);
window.addEventListener("unload",unregisterAdvStatusListener,false);


var advStatusListener =
{
  hmStatus:	null,

  QueryInterface : function(aIID)
  {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsIXULBrowserWindow) ||
        aIID.equals(Components.interfaces.nsISupports) ||
        aIID.equals(Components.interfaces.nsIHttpNotify) ||
        aIID.equals(Components.interfaces.nsIObserver))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  init : function()
  {
    this.hmStatus	 = document.getElementById("hmStatus");


//    HM_OBSERV_SERVICE.addObserver(hmObjNav, "domwindowopened", false);
    HM_OBSERV_SERVICE.addObserver(hmObj, "http-on-examine-response", false);
    HM_OBSERV_SERVICE.addObserver(hmObj, "http-on-modify-request", false);
  },

  destroy : function()
  {
    this.hmStatus     = null;
//    HM_OBSERV_SERVICE.removeObserver(hmObjNav, "domwindowopened");
    HM_OBSERV_SERVICE.removeObserver(hmObj, "http-on-examine-response");
    HM_OBSERV_SERVICE.removeObserver(hmObj, "http-on-modify-request");
  },

  onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
  {
	var hmTab = hmBrowser.selectedBrowser;

    if (aStateFlags & STATE_START) {

//	this.hmStatus.label = hmSettingsHdr + ": " + hmDefStatus;
	this.hmStatus.label = hmSettingsHdr + ": " + hmTab.hmTabStatus;
        this.hmStatus.collapsed = false;

	hmFlag = false;
	hmCurStatus = hmDefStatus;
	hmCurHost = hmDefHost;
//	dump("\nstatus-start");
      }
    else if (aStateFlags & STATE_STOP) {

//     if(hmCurStatus != hmTab.hmTabStatus)  
// {
	this.hmStatus.label = hmSettingsHdr +": " + hmCurStatus;
        hmTab.hmTabStatus = hmCurStatus;
//	}
//	dump("\nstatus-stop: "+ hmTab.hmTabStatus);

    }

  },

  onProgressChange : function (a,b,c,d,e,f){},
  onLocationChange:function(a,b,c){ hmTabSelect();},
  onStatusChange:function(a,b,c,d){},
  onSecurityChange:function(a,b,c){  
}
}

// Utility function, dump an object by reflexion up to niv level (thanks LiveHttpHeaders!)
function dumpall(name,obj,niv) {
  if (!niv) niv=1;
  var dumpdict=new Object();

  dump ("\n\n-------------------------------------------------------\n");
  dump ("Dump of the objet: " + name + " (" + niv + " levels)\n");
  dump ("Address: " + obj + "\n");
  dump ("Interfaces: ");
  for (var i in Components.interfaces) {
    try {
      obj.QueryInterface(Components.interfaces[i]);
      dump(""+Components.interfaces[i]+", ");
    } catch (ex) {}
  }
  dump("\n");
  _dumpall(dumpdict,obj,niv,"","");
  dump ("\n\n-------------------------------------------------------\n\n");
  
  for (i in dumpdict) {
    delete dumpdict[i];
  }
}
function _dumpall(dumpdict,obj,niv,tab,path) {

  if (obj in dumpdict) {
    dump(" (Already dumped)");
  } else {
    dumpdict[obj]=1;
    
    var i,r,str,typ;
    for (i in obj) {
      try {
        str = String(obj[i]).replace(/\n/g,"\n"+tab);
      } catch (ex) {
        str = String(ex);
      }
      try {
        typ = ""+typeof(obj[i]);
      } catch (ex) {
        typ = "unknown";
      }
      dump ("\n" + tab + i + " (" + typ + (path?", " + path:"") +"): " + str);
      if ((niv>1) && (typ=="object")) {
        _dumpall(dumpdict,obj[i],niv-1,tab+"\t",(path?path+"->"+i:i));
      }
    }
  }
}
// Utility function to save data to clipboard
function toClipboard(data) {
  if (data) {
    // clipboard helper
    try
    {
      const clipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
      clipboardHelper.copyString(data);
    } catch(e) {
      // do nothing, later code will handle the error
      dump("Unable to get the clipboard helper\n");
    }
  }
}
